'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (configuration) {
	var lines = Object.entries(configuration.description).map(function (entry) {
		var _entry = (0, _slicedToArray3.default)(entry, 2),
		    name = _entry[0],
		    desc = _entry[1];

		var alias = Object.entries(configuration.alias).find(function (entry) {
			return entry[1] === name;
		}).map(function (entry) {
			return entry[0];
		})[0];
		var defaults = configuration.default[name];
		return [[name, alias].filter(Boolean), desc, defaults].filter(Boolean);
	});

	var longest = lines.map(function (line) {
		var _line = (0, _slicedToArray3.default)(line, 1),
		    flags = _line[0];

		return flags.reduce(function (sum, flag) {
			return sum + flag.length;
		}, 0);
	}).sort(Number)[0];

	return lines.map(function (line) {
		var _line2 = (0, _slicedToArray3.default)(line, 3),
		    flags = _line2[0],
		    desc = _line2[1],
		    defaults = _line2[2];

		var fs = flags.map(function (flag) {
			return flag.length > 1 ? `--${flag}` : `-${flag}`;
		});
		var ds = defaults ? `, defaults to: ${defaults}` : '';
		var length = flags.reduce(function (sum, flag) {
			return sum + flag.length;
		}, 0);
		return `${fs.join(',')}${' '.repeat(4 + longest - length)}${desc}${ds}`;
	}).join('\n');
};

module.exports = exports['default'];