'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = isIgnored;

var _semver = require('semver');

var _semver2 = _interopRequireDefault(_semver);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var WILDCARDS = [function (c) {
	return c.match(/^(Merge pull request)|(Merge (.*?) into (.*?)|(Merge branch (.*?))$)/);
}, function (c) {
	return c.match(/^(R|r)evert (.*)/);
}, function (c) {
	return c.match(/^(fixup|squash)!/);
}, function (c) {
	return _semver2.default.valid(c);
}];

function isIgnored() {
	var commit = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

	return WILDCARDS.some(function (w) {
		return w(commit);
	});
}
module.exports = exports['default'];